;QChan beeper music engine by Shiru (shiru@mail.ru) 03'11
;Four channels of tone with global volumes, per-pattern tempo and decays
;One channel of interrupting drums, no ROM data required
;Feel free to do whatever you want with the code, it is PD

OP_NOP	equ #00
OP_ORC	equ #b1

	module qchan

play
	di
	ld a,(hl)
	inc hl
	ld (readLoop.ch0vol),a
	ld a,(hl)
	inc hl
	ld (readLoop.ch1vol),a
	ld a,(hl)
	inc hl
	ld (readLoop.ch2vol),a
	ld a,(hl)
	inc hl
	ld (readLoop.ch3vol),a
	ld (readLoop.orderPtr),hl
	ld hl,0
	ld (readLoop.frq0),hl
	ld (readLoop.frq1),hl
	ld (readLoop.frq2),hl
	ld (readLoop.frq3),hl
	ld a,l
	ld (soundLoop.vol0),a
	ld (soundLoop.vol1),a
	ld (soundLoop.vol2),a
	ld (soundLoop.vol3),a
	ld (soundLoop.frameCnt),a
	ld (stopPlayer.oldSP),sp
	in a,(#1f)
	and #1f
	ld a,OP_NOP
	jr nz,$+4
	ld a,OP_ORC
	ld (soundLoop.checkKempston),a
	exx
	push hl
	push iy
	jr readLoop.nextPosition

readLoop
.musicPtr=$+1
	ld de,0
.readRow
	ld a,(de)
	cp 128
	jp nz,.readNotes
.nextPosition
.orderPtr=$+1
	ld hl,0
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,d
	or e
	jr z,.orderLoop
	ld (.orderPtr),hl
	ld a,(de)
	ld (soundLoop.frameMax),a
	inc de
	ld a,(de)
	ld (soundLoop.ch0decay),a
	inc de
	ld a,(de)
	ld (soundLoop.ch1decay),a
	inc de
	ld a,(de)
	ld (soundLoop.ch2decay),a
	inc de
	ld a,(de)
	ld (soundLoop.ch3decay),a
	inc de
	jp .readRow
.orderLoop
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld (.orderPtr),de
	jp .nextPosition
.readNotes
	ld h,freqTable/256
	inc de
	or a
	jr z,.noNote0
	ld l,a
	ld c,(hl)
	inc l
	ld b,(hl)
	ld (.frq0),bc
.ch0vol=$+1
	ld a,16
	ld (soundLoop.vol0),a
.noNote0
	ld a,(de)
	inc de
	or a
	jr z,.noNote1
	ld l,a
	ld c,(hl)
	inc l
	ld b,(hl)
	ld (.frq1),bc
.frq1=$+1
	ld sp,0
.ch1vol=$+1
	ld a,16
	ld (soundLoop.vol1),a
.noNote1
	ld a,(de)
	inc de
	or a
	jr z,.noNote2
	ld l,a
	ld c,(hl)
	inc l
	ld b,(hl)
	ld (.frq2),bc
	exx
.frq2=$+1
	ld de,0
	exx
.ch2vol=$+1
	ld a,16
	ld (soundLoop.vol2),a
.noNote2
	ld a,(de)
	inc de
	or a
	jr z,.noNote3
	ld l,a
	ld c,(hl)
	inc l
	ld b,(hl)
	ld (.frq3),bc
	exx
.frq3=$+1
	ld bc,0
	exx
.ch3vol=$+1
	ld a,16
	ld (soundLoop.vol3),a
.noNote3
	ld (.musicPtr),de
	ld a,(de)
	cp 129
	jr c,.noDrum
	inc de
	ld (.musicPtr),de

	ld b,128
	sub b
	add a,a
	ld c,a
	ld e,a
	ld l,a
	ld h,a
.drum1
	dec c
	jr nz,.drum2
	ld c,e
	and 16
	out (#fe),a
.drum2
	ld a,l
	add a,11
	xor h
	ld l,a
	ld a,h
	add a,12
	xor l
	ld h,a
	djnz .drum1

.noDrum
	xor a

.frq0=$+1
	ld de,0

soundLoopRepeat
	exa

.prevCnt1=$+1
	ld hl,0
	ld c,64

soundLoop
	add ix,de		;15
	sbc a,a			;4
.vol0=$+1
	and 0			;7
	ld b,a			;4
	add hl,sp		;11
	sbc a,a			;4
.vol1=$+1
	and 0			;7
	or b			;4
	ld b,a			;4
	exx				;4
	add iy,de		;15
	sbc a,a			;4
.vol2=$+1
	and 0			;7
	exx				;4
	or b			;4
	ld b,a			;4
	exx				;4
	add hl,bc		;11
	sbc a,a			;4
.vol3=$+1
	and 0			;7
	exx				;4
	or b			;4
	jr z,.noOut		;7/12
	ld b,a			;4
	ld a,16			;7
	out (#fe),a		;11
	ld a,b			;4
	djnz $			;~
	cpl				;4
.noOut
	add a,17		;7
	ld b,a			;4
	xor a			;4
	out (#fe),a		;11
	djnz $			;~
	dec c			;4
	jp nz,soundLoop	;10=~404t

	ld (soundLoopRepeat.prevCnt1),hl

.frameCnt=$+1
	ld a,0
	ld c,a
.ch0decay=$+1
	and 0
	jr nz,.ch0dskip
	ld hl,.vol0
	or (hl)
	jr z,$+3
	dec (hl)
.ch0dskip
	ld a,c
.ch1decay=$+1
	and 0
	jr nz,.ch1dskip
	ld hl,.vol1
	or (hl)
	jr z,$+3
	dec (hl)
.ch1dskip
	ld a,c
.ch2decay=$+1
	and 0
	jr nz,.ch2dskip
	ld hl,.vol2
	or (hl)
	jr z,$+3
	dec (hl)
.ch2dskip
	ld a,c
.ch3decay=$+1
	and 0
	jr nz,.ch3dskip
	ld hl,.vol3
	or (hl)
	jr z,$+3
	dec (hl)
.ch3dskip
	ld hl,.frameCnt
	inc (hl)

	exa
	inc a
.frameMax=$+1
	cp 20
	jp c,soundLoopRepeat

	in a,(#1f)
	ld c,a
	in a,(#fe)
	cpl
.checkKempston
	or c
	and #1f
	jr nz,stopPlayer
	jp readLoop

stopPlayer
.oldSP=$+1
	ld sp,0
	pop iy
	pop hl
	exx
	ei
	ret


	align 256
freqTable
	dw 0
	dw 247,262,277,294,311,330,349,370,392,416,440,467
	dw 494,524,555,588,623,660,699,741,785,832,881,934
	dw 989,1048,1110,1176,1246,1320,1399,1482,1570,1664,1763,1868
	dw 1979,2096,2221,2353,2493,2641,2798,2965,3141,3328,3526,3736
	dw 3958,4193,4442,4707,4987,5283,5597,5930,6283,6656,7052,7472
	dw 0

	endmodule