#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <string.h>



unsigned char *xm;



int read_word(int off)
{
	return xm[off]+(xm[off+1]<<8);
}



int read_dword(int off)
{
	return xm[off]+(xm[off+1]<<8)+(xm[off+2]<<16)+(xm[off+3]<<24);
}



void cleanup(void)
{
	free(xm);
}



int main(int argc, char* argv[])
{
	FILE *file;
	int size;
	int order_len;
	int order_loop;
	int channels;
	int patterns;
	int tempo;
	int bpm;
	int i,j,k,pp,patlen;
	int tag,note,ins,vol,fx,param,drum;
	int row[4];
	int decay[4];
	int gvol[4];
	int speed;
	char name[1024];

	if(argc<2)
	{
		printf("xm2qchan v2 converter by Shiru (shiru@mail.ru) 03'11\n");
		printf("Usage: xm2qchan filename.xm\n");
		exit(0);
	}

	file=fopen(argv[1],"rb");

	if(!file)
	{
		printf("Error: Can't open file %s\n",argv[1]);
		exit(-1);
	}

	fseek(file,0,SEEK_END);
	size=ftell(file);
	fseek(file,0,SEEK_SET);

	xm=(unsigned char*)malloc(size);
	fread(xm,size,1,file);
	fclose(file);

	atexit(cleanup);

	if(memcmp(xm,"Extended Module: ",17))
	{
		printf("Error: Not XM module\n");
		exit(-1);
	}

	order_len=read_word(60+4);
	order_loop=read_word(60+6);
	channels=read_word(60+8);
	patterns=read_word(60+10);
	tempo=read_word(60+16);
	bpm=read_word(60+18);

	if(!order_len)
	{
		printf("Error: Module should have at least one order position\n");
		exit(-1);
	}

	if(channels<4)
	{
		printf("Error: Module should have at least four channels\n");
		exit(-1);
	}

	strcpy(name,argv[1]);
	name[strlen(argv[1])-2]='a';
	name[strlen(argv[1])-1]='s';
	name[strlen(argv[1])  ]='m';
	name[strlen(argv[1])+1]=0;

	file=fopen(name,"wt");

	for(i=0;i<4;i++) gvol[i]=15;

	pp=60+20+256;
	for(i=0;i<xm[60+20];i++) pp=pp+read_dword(pp)+read_word(pp+7);
	pp+=read_dword(pp);

	for(k=0;k<channels;k++)
	{
		if(xm[pp]&0x80)
		{
			tag=xm[pp++];
			if(tag&0x01) note =xm[pp++]; else note =0;
			if(tag&0x02) ins  =xm[pp++]; else ins  =0;
			if(tag&0x04) vol  =xm[pp++]; else vol  =0;
			if(tag&0x08) fx   =xm[pp++]; else fx   =0;
			if(tag&0x10) param=xm[pp++]; else param=0;
		}
		else
		{
			note =xm[pp++];
			ins  =xm[pp++];
			vol  =xm[pp++];
			fx   =xm[pp++];
			param=xm[pp++];
		}
		if(k<4&&vol)
		{
			gvol[k]=(vol-16)/4;
			if(gvol[k]>15) gvol[k]=15;
		}
	}

	fprintf(file,"module\n\tdb #%2.2x,#%2.2x,#%2.2x,#%2.2x\n",gvol[0],gvol[1],gvol[2],gvol[3]);

	for(j=0;j<order_len;j++)
	{
		if(j==order_loop) fprintf(file,".loop\n");
		fprintf(file,"\tdw .p%2.2x\n",xm[60+20+j]);
	}

	fprintf(file,"\tdw 0\n\tdw .loop\n");

	for(i=0;i<patterns;i++)
	{
		for(j=0;j<4;j++) decay[j]=0;

		pp=60+20+256;
		for(j=0;j<i;j++) pp=pp+read_dword(pp)+read_word(pp+7);

		patlen=read_word(pp+5);
		pp+=read_dword(pp);

		for(j=0;j<patlen;j++)
		{
			for(k=0;k<channels;k++)
			{
				if(xm[pp]&0x80)
				{
					tag=xm[pp++];
					if(tag&0x01) note =xm[pp++]; else note =0;
					if(tag&0x02) ins  =xm[pp++]; else ins  =0;
					if(tag&0x04) vol  =xm[pp++]; else vol  =0;
					if(tag&0x08) fx   =xm[pp++]; else fx   =0;
					if(tag&0x10) param=xm[pp++]; else param=0;
				}
				else
				{
					note =xm[pp++];
					ins  =xm[pp++];
					vol  =xm[pp++];
					fx   =xm[pp++];
					param=xm[pp++];
				}
				if(k<4)
				{
					if(!decay[k])
					{
						switch(ins)
						{
						case 1: decay[k]=1; break;
						case 2: decay[k]=3; break;
						case 3: decay[k]=7; break;
						case 4: decay[k]=15; break;
						case 5: decay[k]=31; break;
						case 6: decay[k]=63; break;
						case 7: decay[k]=127; break;
						case 8: decay[k]=255; break;
						}
					}
				}
				if(fx==0x0f)
				{
					if(param<0x20) tempo=param; else bpm=param;
				}
			}
		}

		for(j=0;j<4;j++) if(!decay[j]) decay[j]=1;

		speed=2500*tempo/bpm/7;

		if(speed<1||speed>255)
		{
			printf("Warning: Tempo or BPM is out of range (ptn:%2.2x row:%2.2x)\n");
		}

		fprintf(file,".p%2.2x\n",i);
		fprintf(file,"\tdb #%2.2x,#%2.2x,#%2.2x,#%2.2x,#%2.2x\n",speed,decay[0],decay[1],decay[2],decay[3]);

		pp=60+20+256;
		for(j=0;j<i;j++) pp=pp+read_dword(pp)+read_word(pp+7);

		patlen=read_word(pp+5);
		pp+=read_dword(pp);

		for(j=0;j<patlen;j++)
		{
			drum=0;

			for(k=0;k<channels;k++)
			{
				if(xm[pp]&0x80)
				{
					tag=xm[pp++];
					if(tag&0x01) note =xm[pp++]; else note =0;
					if(tag&0x02) ins  =xm[pp++]; else ins  =0;
					if(tag&0x04) vol  =xm[pp++]; else vol  =0;
					if(tag&0x08) fx   =xm[pp++]; else fx   =0;
					if(tag&0x10) param=xm[pp++]; else param=0;
				}
				else
				{
					note =xm[pp++];
					ins  =xm[pp++];
					vol  =xm[pp++];
					fx   =xm[pp++];
					param=xm[pp++];
				}
				if(k<4)
				{
					row[k]=0;
					if(ins<9&&note>0&&note<=5*12+1) row[k]=note*2;
					if(note==97) row[k]=122;
				}
				if(ins>=9) drum=129+(ins-9);
			}

			fprintf(file,"\tdb #%2.2x,#%2.2x,#%2.2x,#%2.2x",row[0],row[1],row[2],row[3]);
			if(drum) fprintf(file,",#%2.2x",drum);
			fprintf(file,"\n");
		}

		fprintf(file,"\tdb #80\n");
	}

	fclose(file);

	exit(0);
}